import { Action, fromAction, ErrorAction } from '@shopify/app-bridge-core/actions/Error';
import { AnyAction, MetaAction } from '../types';
export { AppActionType, AppBridgeError, invalidOriginAction, throwError, isErrorEventName, permissionAction, } from '@shopify/app-bridge-core/actions/Error';
export { Action, fromAction, ErrorAction };
export declare type Payload = MetaAction | AnyAction;
export declare enum Message {
    MISSING_PAYLOAD = "Missing payload",
    INVALID_PAYLOAD_ID = "Id in payload is missing or invalid"
}
export declare function invalidPayload<A extends MetaAction>(action: A, message?: string): ErrorAction;
export declare function invalidActionType<A extends MetaAction>(action: A, message?: string): ErrorAction;
export declare function invalidAction<A extends MetaAction>(action: A, message?: string): ErrorAction;
export declare function unexpectedAction<A extends MetaAction>(action: A, message?: string): ErrorAction;
export declare function unsupportedOperationAction<A extends MetaAction>(action: A, message?: string): ErrorAction;
export declare function persistenceAction<A extends MetaAction>(action: A, message?: string): ErrorAction;
export declare function networkAction<A extends MetaAction>(action: A, message?: string): ErrorAction;
